var db = null;
var img_dir = "img/map/";

var Loader = function () { };
Loader.prototype = {
    require: function (scripts, callback) {
        this.loadCount      = 0;
        this.totalRequired  = scripts.length;
        this.callback       = callback;

        for (var i = 0; i < scripts.length; i++) {
            this.writeScript(scripts[i]);
        }
    },
    loaded: function (evt) {
        this.loadCount++;

        if (this.loadCount == this.totalRequired && typeof this.callback == 'function') this.callback.call();
    },
    writeScript: function (src) {
        var self = this;
        var s = document.createElement('script');
        s.type = "text/javascript";
        s.async = true;
        s.src = src;
        s.addEventListener('load', function (e) { self.loaded(e); }, false);
        var head = document.getElementsByTagName('head')[0];
        head.appendChild(s);
    }
};

(function() {
/**
   * Decimal adjustment of a number.
   * https://developer.mozilla.org/en/docs/Web/JavaScript/Reference/Global_Objects/Math/round
   *
   * @param {String}  type  The type of adjustment.
   * @param {Number}  value The number.
   * @param {Integer} exp   The exponent (the 10 logarithm of the adjustment base).
   * @returns {Number} The adjusted value.
   */
  function decimalAdjust(type, value, exp) {
    // If the exp is undefined or zero...
    if (typeof exp === 'undefined' || +exp === 0) {
      return Math[type](value);
    }
    value = +value;
    exp = +exp;
    // If the value is not a number or the exp is not an integer...
    if (isNaN(value) || !(typeof exp === 'number' && exp % 1 === 0)) {
      return NaN;
    }
    // Shift
    value = value.toString().split('e');
    value = Math[type](+(value[0] + 'e' + (value[1] ? (+value[1] - exp) : -exp)));
    // Shift back
    value = value.toString().split('e');
    return +(value[0] + 'e' + (value[1] ? (+value[1] + exp) : exp));
  }

  // Decimal round
  if (!Math.round10) {
    Math.round10 = function(value, exp) {
      return decimalAdjust('round', value, exp);
    };
  }
  // Decimal floor
  if (!Math.floor10) {
    Math.floor10 = function(value, exp) {
      return decimalAdjust('floor', value, exp);
    };
  }
  // Decimal ceil
  if (!Math.ceil10) {
    Math.ceil10 = function(value, exp) {
      return decimalAdjust('ceil', value, exp);
    };
  }
})();

// Ionic Starter App

// angular.module is a global place for creating, registering and retrieving Angular modules
// 'starter' is the name of this angular module example (also set in a <body> attribute in index.html)
// the 2nd parameter is an array of 'requires'
angular.module('iOnRoad', ['iOnRoad.controllers', 'iOnRoad.services', 'iOnRoad.directives',
    'ionic',
    'ngCordova', 'ngCordovaOauth',
    'angles'])

    .run(function ($rootScope, $state, $stateParams, $ionicPlatform, $ionicLoading, $timeout, $cordovaLocalNotification, _Settings, ParkingService) {
        $rootScope.$state = $state;
        $rootScope.$stateParams = $stateParams;
        $rootScope.horizontal = false;
        $rootScope.redir = false;

        // Responsible for showing a loader while
        // resolving the controlles' dependencies
        $rootScope.$on('loading:show', function () {
            $ionicLoading.show({
                template: "" +
                    "<div>" +
                        "<ion-spinner class='spinner-light'></ion-spinner>" +
                    "</div>"
            });
        });
        $rootScope.$on('loading:hide', function () {
            $ionicLoading.hide();
        });
        $rootScope.$on('$stateChangeStart', function () {
            console.log('please wait...');
            $rootScope.$broadcast('loading:show');
        });
        $rootScope.$on('$stateChangeSuccess', function () {
            console.log('done');
            $rootScope.$broadcast('loading:hide');
        });

        // Go to parking if user clicked on the notification
        $rootScope.$on('$cordovaLocalNotification:click', function(event, notification, state) {
            if (!$rootScope.redir) {
                $rootScope.redir = true;
                $state.go('parking');

                // Cler the alarm from the DB.
                ParkingService.cancelAlarm(function () {
                    // Nothing to do here.
                });
            }
        });
        // When the notification is clicked, clear the alarm from the DB.
        $rootScope.$on('$cordovaLocalNotification:trigger', function(event, notification, state) {
            // Cler the alarm from the DB.
            ParkingService.cancelAlarm(function () {
                // Nothing to do here.
            });
        });



        // Define the default settings
        if (!$rootScope.Settings) {
            $rootScope.Settings = {
                speed_units: true,
                selected_tailgating_alert_time_value: 0.7,
                prodashboard: false,
            };
        }

        // Handle the initialization of the settings in rootscope
        $rootScope.ReloadSettings = function () {
            // Load the settings from the settings file
            if (!_Settings.initialized())
                return;

            _Settings.load();

            // Common Settings
            _Settings.getValue("should_reset_settings", "boolean",
                function (result) {
                    $rootScope.Settings.should_reset_settings = result;
                },
                function (error) {
                    $rootScope.Settings.should_reset_settings = true;
                });

            // Dev Settings
            _Settings.getValue("debug_mode", "boolean",
                function (result) {
                    $rootScope.Settings.debug_mode = result;
                },
                function (error) {
                    $rootScope.Settings.debug_mode = true;
                });
            _Settings.getValue("show_debug_info", "boolean",
                function (result) {
                    $rootScope.Settings.show_debug_info = result;
                },
                function (error) {
                    $rootScope.Settings.show_debug_info = true;
                });
            _Settings.getValue("enable_sounds", "boolean",
                function (result) {
                    $rootScope.Settings.enable_sounds = result;
                },
                function (error) {
                    $rootScope.Settings.enable_sounds = true;
                });
            _Settings.getValue("is_first_app_run", "boolean",
                function (result) {
                    $rootScope.Settings.is_first_app_run = result;
                },
                function (error) {
                    $rootScope.Settings.is_first_app_run = true;
                });

            // Basic Settings
            _Settings.getValue("speed_units", "boolean",
                function (result) {
                    $rootScope.Settings.speed_units = result;
                },
                function (error) {
                    $rootScope.Settings.speed_units = true;
                });
            _Settings.getValue("marker_information", "boolean",
                function (result) {
                    $rootScope.Settings.marker_information = result;
                },
                function (error) {
                    $rootScope.Settings.marker_information = false;
                });
            _Settings.getValue("list_navigation_app", "array",
                function (result) {
                    $rootScope.Settings.list_navigation_app = result;
                },
                function (error) {
                    $rootScope.Settings.list_navigation_app = [];
                });
            _Settings.getValue("list_navigation_app_values", "array",
                function (result) {
                    $rootScope.Settings.list_navigation_app_values = result;
                },
                function (error) {
                    $rootScope.Settings.list_navigation_app_values = [];
                });
            _Settings.getValue("selected_navigation_app_name", "string",
                function (result) {
                    $rootScope.Settings.selected_navigation_app_name = result;
                },
                function (error) {
                    $rootScope.Settings.selected_navigation_app_name = "";
                });
            _Settings.getValue("selected_navigation_pkg_name", "string",
                function (result) {
                    $rootScope.Settings.selected_navigation_pkg_name = result;
                },
                function (error) {
                    $rootScope.Settings.selected_navigation_pkg_name = "";
                });
            _Settings.getValue("parking_notification", "boolean",
                function (result) {
                    $rootScope.Settings.parking_notification = result;
                },
                function (error) {
                    $rootScope.Settings.parking_notification = false;
                });

            //// Backup Settings
            _Settings.getValue("cloud_backup", "boolean",
                function (result) {
                    $rootScope.Settings.cloud_backup = result;
                },
                function (error) {
                    $rootScope.Settings.cloud_backup = false;
                });

            //// Alerts Settings
            _Settings.getValue("collision_alert", "boolean",
                function (result) {
                    $rootScope.Settings.collision_alert = result;
                },
                function (error) {
                    $rootScope.Settings.collision_alert = false;
                });
            _Settings.getValue("off_road_warning", "boolean",
                function (result) {
                    $rootScope.Settings.off_road_warning = result;
                },
                function (error) {
                    $rootScope.Settings.off_road_warning = false;
                });
            _Settings.getValue("tailgating_alert", "boolean",
                function (result) {
                    $rootScope.Settings.tailgating_alert = result;
                },
                function (error) {
                    $rootScope.Settings.tailgating_alert = false;
                });
            _Settings.getValue("speeding_alert", "boolean",
                function (result) {
                    $rootScope.Settings.speeding_alert = result;
                },
                function (error) {
                    $rootScope.Settings.speeding_alert = false;
                });

            //// Advanced Settings
            _Settings.getValue("speed_sign_alert", "boolean",
                function (result) {
                    $rootScope.Settings.speed_sign_alert = result;
                },
                function (error) {
                    $rootScope.Settings.speed_sign_alert = false;
                });
            _Settings.getValue("show_speed_sign", "array",
                function (result) {
                    $rootScope.Settings.show_speed_sign = result;
                },
                function (error) {
                    $rootScope.Settings.show_speed_sign = [];
                });
            _Settings.getValue("show_speed_sign_values", "array",
                function (result) {
                    $rootScope.Settings.show_speed_sign_values = result;
                },
                function (error) {
                    $rootScope.Settings.show_speed_sign_values = [];
                });
            _Settings.getValue("selected_show_speed_sign", "string",
                function (result) {
                    $rootScope.Settings.selected_show_speed_sign = result;
                },
                function (error) {
                    $rootScope.Settings.selected_show_speed_sign = false;
                });
            _Settings.getValue("selected_tsr_time_value", "long",
                function (result) {
                    $rootScope.Settings.selected_tsr_time_value = result;
                },
                function (error) {
                    $rootScope.Settings.selected_tsr_time_value = false;
                });
            _Settings.getValue("limit_max_speed", "boolean",
                function (result) {
                    $rootScope.Settings.limit_max_speed = result;
                },
                function (error) {
                    $rootScope.Settings.limit_max_speed = false;
                });
            _Settings.getValue("max_speed_value", "int",
                function (result) {
                    $rootScope.Settings.max_speed_value = result;
                },
                function (error) {
                    $rootScope.Settings.max_speed_value = 65;
                });
            _Settings.getValue("speed_limit_range_top", "int",
                function (result) {
                    $rootScope.Settings.speed_limit_range_top = result;
                },
                function (error) {
                    $rootScope.Settings.speed_limit_range_top = 140;
                });
            _Settings.getValue("speed_limit_range_bottom", "int",
                function (result) {
                    $rootScope.Settings.speed_limit_range_bottom = result;
                },
                function (error) {
                    $rootScope.Settings.speed_limit_range_bottom = 50;
                });
            //_Settings.getValue("tailgating_alert_time", "int",
            //    function(result) {
            // $rootScope.Settings.tailgating_alert_time = result / 1000;
            // },
            //    function(error) {
            // return 1;
            // });
            _Settings.getValue("selected_tailgating_alert_time_value", "int",
                function (result) {
                    $rootScope.Settings.selected_tailgating_alert_time_value = result / 1000;
                },
                function (error) {
                    $rootScope.Settings.selected_tailgating_alert_time_value = 0;
                });
            _Settings.getValue("selected_tailgating_alert_time", "string",
                function (result) {
                    $rootScope.Settings.selected_tailgating_alert_time = result;
                },
                function (error) {
                    $rootScope.Settings.selected_tailgating_alert_time = "";
                });
            _Settings.getValue("show_hmw_values", "array",
                function (result) {
                    $rootScope.Settings.show_hmw_values = result;
                },
                function (error) {
                    $rootScope.Settings.show_hmw_values = [];
                });
            _Settings.getValue("tailgating_alert_time", "array",
                function (result) {
                    $rootScope.Settings.tailgating_alert_time = result;
                },
                function (error) {
                    $rootScope.Settings.tailgating_alert_time = [];
                });

            _Settings.getValue("limit_video_length", "boolean",
                function (result) {
                    $rootScope.Settings.limit_video_length = result;
                },
                function (error) {
                    $rootScope.Settings.limit_video_length = false;
                });
            //_Settings.getValue("video_max_length", "int",
            //    function(result) {
            // $rootScope.Settings.video_max_length = result;
            // },
            //    function(error) {
            // return 0;
            // });
            _Settings.getValue("video_max_length_value", "int",
                function (result) {
                    $rootScope.Settings.video_max_length_value = result;
                },
                function (error) {
                    $rootScope.Settings.video_max_length_value = [];
                });
            _Settings.getValue("video_max_length", "string",
                function (result) {
                    $rootScope.Settings.video_max_length = result;
                },
                function (error) {
                    $rootScope.Settings.video_max_length = [];
                });
            _Settings.getValue("video_max_length_names", "array",
                function (result) {
                    $rootScope.Settings.video_max_length_names = result;
                },
                function (error) {
                    $rootScope.Settings.video_max_length_names = false;
                });
            _Settings.getValue("video_max_length_values", "array",
                function (result) {
                    $rootScope.Settings.video_max_length_values = result;
                },
                function (error) {
                    $rootScope.Settings.video_max_length_values = false;
                });

            // New
            _Settings.getValue("com.ionroad.prodashboard", "boolean",
                function (result) {
                    $rootScope.Settings.prodashboard = result;
                },
                function (error) {
                    $rootScope.Settings.prodashboard = true;
                });
        };
        $rootScope.ReloadSettings();
        $rootScope.$on('$viewContentLoading',
            function(event, viewConfig){
                if (viewConfig.view.name == "home") {
                    $rootScope.ReloadSettings();
                }
            });

        $rootScope.CheckInternetConnection = function() {
            if(window.Connection) {
                $rootScope.$apply(function() {
                    if(navigator.connection.type == Connection.NONE) {
                        $rootScope.connected_to_internet = false;
                    }
                    else {
                        $rootScope.connected_to_internet = true;
                    }
                });
                console.log("Periodic internet connection check returned status: " + navigator.connection.type);
            }
        };

        $ionicPlatform.ready(function () {
            // Hide the accessory bar by default (remove this to show the accessory bar above the keyboard
            // for form inputs)
            if (window.cordova && window.cordova.plugins.Keyboard) {
                cordova.plugins.Keyboard.hideKeyboardAccessoryBar(true);
            }
            if (window.StatusBar) {
                StatusBar.styleDefault();
            }

            // Check internet connection
            $rootScope.connected_to_internet = true;

            $rootScope.CheckInternetConnection();
            var checkInternetConnectionTimer = setInterval(function() {
                $rootScope.CheckInternetConnection();
            }, 1000 * 15);

            // Load remote scripts
            $rootScope.loaded_remote_scripts = false;
            $rootScope.$watch('connected_to_internet', function(newValue, oldValue) {
                if ((oldValue != newValue) && (newValue === true)) {
                    if (!$rootScope.loaded_remote_scripts) {
                        var l = new Loader();
                        l.require([
                            "https://maps.googleapis.com/maps/api/js?sensor=false",
                            "lib/googlemaps/markerwithlabel.js"],
                            function() {
                                $rootScope.loaded_remote_scripts = true;
                                console.log("Successfully loaded remote scripts");
                            });
                    }
                }
            });

            // Orientation-change-related-code
            window.addEventListener('orientationchange', function() {
                switch(window.orientation)
                {
                    case -90:
                    case 90:
                    { // landscape
                        $rootScope.horizontal = true;
                        break;
                    }
                    default: // portrait
                    {
                        $rootScope.horizontal = false;
                        break;
                    }
                }
            });

            // Initialize the database connection
            try {
                // Open the connetion to the db
                db = window.sqlitePlugin.openDatabase({
                    name: "ionroad.db",
                    androidDatabaseImplementation: 2,
                    createFromLocation: 1
                });
            }
            catch (e) {
                console.log("Error connecting to the database", e);
            }
        });
    })

    .config(function ($stateProvider, $compileProvider, $urlRouterProvider, $ionicConfigProvider) {
        $ionicConfigProvider.form.toggle('small');

        // Remove the label from the back button
        $ionicConfigProvider.backButton.previousTitleText(false).text('');

        // White-list image URLs so Angular allows file:// URLs
        $compileProvider.imgSrcSanitizationWhitelist(/^\s*(https?|ftp|mailto|file|tel|blob):|data:image\//);

        // Ionic uses AngularUI Router which uses the concept of states
        // Learn more here: https://github.com/angular-ui/ui-router
        // Set up the various states which the app can be in.
        // Each state's controller can be found in controllers.js
        $stateProvider

            .state('splash', {
                url: '/',
                templateUrl: 'templates/splash.html',
                controller: function ($scope, $state, $ionicPlatform, $localStorage, _Settings) {
                    $ionicPlatform.ready(function () {
                        $scope.is_first_run = false;
                        $scope.is_resume = true;

                        if (!_Settings.initialized()) {
                            $scope.is_first_run = true;
                            $scope.is_resume = false;
                            if (!$scope.redir) {
                                $scope.redir = true;
                                $state.go('intro');
                            }
                            return;
                        }

                        _Settings.load();

                        _Settings.getValue("is_first_app_run", "boolean",
                            function (result) {
                                if (result) {
                                    $scope.is_first_run = true;
                                    $scope.is_resume = false;
                                    if (!$scope.redir) {
                                        $scope.redir = true;
                                        $state.go('intro');
                                    }
                                }
                                else {
                                    _Settings.getValue("is_new_session", "boolean",
                                        function (result) {
                                            if (result) {
                                                // The app just started
                                                if (!$scope.redir) {
                                                    $scope.redir = true;
                                                    $state.go('home');
                                                }
                                            }
                                            else {
                                                // The app resumed from augmented state
                                                var session = $localStorage.getObject("lastState");
                                                $state.go(session.lastState.state, session.lastState.parms);
                                            }
                                        }, function (error) {
                                            // Something happened, let's log it and move to the home screen
                                            console.log(error);
                                            if (!$scope.redir) {
                                                $scope.redir = true;
                                                $state.go('home');
                                            }
                                        });
                                }
                            }, function (error) {
                                // Something happened, let's log it and move to the home screen
                                console.log(error);
                                if (!$scope.redir) {
                                    $scope.redir = true;
                                    $state.go('home');
                                }
                            });
                    });
                }
            })
            .state('home', {
                url: '/home',
                templateUrl: 'templates/home.html',
                controller: 'HomeCtrl',
                resolve: {
                    _LatestRuns:  ["HomeService", "_Utils", "$q", "$rootScope", function(HomeService, _Utils, $q, $rootScope) {
                        var deferred = $q.defer();

                        HomeService.getLatestRuns(function (runs) {
                            if (!runs) {
                                deferred.resolve(null);
                            }
                            else {
                                var result = [];
                                for (i = 0; i < runs.length; i++) {
                                     result[i] = {
                                         RunId: runs[i].RunId,
                                         When: _Utils.getDriveDateText(runs[i].EndTime),
                                         StartTime: _Utils.getTime(runs[i].StartTime),
                                         StartTimeMetric: _Utils.getTimeMetric(runs[i].StartTime),
                                         EndTime: _Utils.getTime(runs[i].EndTime),
                                         EndTimeMetric: _Utils.getTimeMetric(runs[i].EndTime),
                                         Distance: _Utils.getDistance(runs[i].TotalDistance),
                                         DistanceMetric: _Utils.getDistanceMetric(runs[i].TotalDistance, $rootScope.Settings.speed_units),
                                         Duration: _Utils.getDuration(runs[i].StartTime, runs[i].EndTime),
                                         DurationMetric: _Utils.getDurationMetric(runs[i].StartTime, runs[i].EndTime)
                                     };
                                 }

                                 deferred.resolve(result);
                            }
                        });

                        return deferred.promise;
                    }],

                    _ParkingInfo: function(ParkingService, _Utils, $q) {
                        var deferred = $q.defer();

                        ParkingService.getParkingInfo(function (parking) {
                            if (!parking) {
                                deferred.resolve(null);
                            }
                            else {
                                var result;
                                result = {
                                    Time: parking.Timestamp,
                                    ReadableTime: _Utils.getReadableTimestamp(parking.Timestamp),
                                    ShortTime: _Utils.getTime(parking.Timestamp),
                                    ShortTimeMetric: _Utils.getTimeMetric(parking.Timestamp),
                                    Country: parking.Country,
                                    City: parking.City,
                                    Address: parking.Address,
                                    Longitude: parking.Longitude,
                                    Latitude: parking.Latitude
                                };

                                deferred.resolve(result);
                            }
                        });

                        return deferred.promise;
                    },

                    _IsParkingExists: function(ParkingService, _Utils, $q) {
                        var deferred = $q.defer();

                        ParkingService.isParkingExists(function (result) {
                            deferred.resolve(result);
                        });

                        return deferred.promise;
                    },

                    _UserInfo: function(HomeService, $q) {
                        var deferred = $q.defer();

                        HomeService.getUserInfo(function (result) {
                            deferred.resolve(result);
                        });

                        return deferred.promise;
                    },

                    _ReminderInfo: function(ParkingService, _Utils, $q) {
                        var deferred = $q.defer();

                        ParkingService.getReminderInfo(function (reminder) {
                            if (!reminder) {
                                deferred.resolve(null);
                            }
                            else {
                                // Is the reminder not relevant anymore?
                                var result = {};
                                var now = moment();
                                var reminderTime = moment(reminder.ReminderTime);
                                if (now.diff(reminderTime) >= 0) {
                                    result = {
                                        Time: null,
                                        ShortTime: null,
                                        ShortTimeMetric: null
                                    };

                                    deferred.resolve(result);
                                }
                                else {
                                    result = {
                                        Time: reminder.ReminderTime,
                                        ShortTime: _Utils.getTime(reminder.ReminderTime),
                                        ShortTimeMetric: _Utils.getTimeMetric(reminder.ReminderTime)
                                    };

                                    deferred.resolve(result);
                                }
                            }
                        });

                        return deferred.promise;
                    },

                    _SettingsData: function(_Settings, $q) {
                        var promises = [];
                        var result = {};

                        // Load the settings from the settings file
                        if (!_Settings.initialized())
                            return;

                        _Settings.load();

                        // Common Settings
                        var q_should_reset_settings = $q.defer();
                        promises.push(q_should_reset_settings);
                        _Settings.getValue("should_reset_settings", "boolean",
                            function (res) {
                                result.should_reset_settings = res;
                                q_should_reset_settings.resolve(result.should_reset_settings);
                            },
                            function (error) {
                                result.should_reset_settings = true;
                                q_should_reset_settings.resolve(result.should_reset_settings);
                            });

                        // Dev Settings
                        var q_debug_mode = $q.defer();
                        promises.push(q_debug_mode);
                        _Settings.getValue("debug_mode", "boolean",
                            function (res) {
                                result.debug_mode = res;
                                q_debug_mode.resolve(result.debug_mode);
                            },
                            function (error) {
                                result.debug_mode = true;
                                q_debug_mode.resolve(result.debug_mode);
                            });
                        var q_show_debug_info = $q.defer();
                        promises.push(q_show_debug_info);
                        _Settings.getValue("show_debug_info", "boolean",
                            function (res) {
                                result.show_debug_info = res;
                                q_show_debug_info.resolve(result.show_debug_info);
                            },
                            function (error) {
                                result.show_debug_info = true;
                                q_show_debug_info.resolve(result.show_debug_info);
                            });
                        var q_enable_sounds = $q.defer();
                        promises.push(q_enable_sounds);
                        _Settings.getValue("enable_sounds", "boolean",
                            function (res) {
                                result.enable_sounds = res;
                                q_enable_sounds.resolve(result.enable_sounds);
                            },
                            function (error) {
                                result.enable_sounds = true;
                                q_enable_sounds.resolve(result.enable_sounds);
                            });
                        var q_is_first_app_run = $q.defer();
                        promises.push(q_is_first_app_run);
                        _Settings.getValue("is_first_app_run", "boolean",
                            function (res) {
                                result.is_first_app_run = res;
                                q_is_first_app_run.resolve(result.is_first_app_run);
                            },
                            function (error) {
                                result.is_first_app_run = true;
                                q_is_first_app_run.resolve(result.is_first_app_run);
                            });

                        // Basic Settings
                        var q_speed_units = $q.defer();
                        promises.push(q_speed_units);
                        _Settings.getValue("speed_units", "boolean",
                            function (res) {
                                result.speed_units = res;
                                q_speed_units.resolve(result.speed_units);
                            },
                            function (error) {
                                result.speed_units = true;
                                q_speed_units.resolve(result.speed_units);
                            });
                        var q_marker_information = $q.defer();
                        promises.push(q_marker_information);
                        _Settings.getValue("marker_information", "boolean",
                            function (res) {
                                result.marker_information = res;
                                q_marker_information.resolve(result.marker_information);
                            },
                            function (error) {
                                result.marker_information = false;
                                q_marker_information.resolve(result.marker_information);
                            });
                        var q_list_navigation_app = $q.defer();
                        promises.push(q_list_navigation_app);
                        _Settings.getValue("list_navigation_app", "array",
                            function (res) {
                                result.list_navigation_app = res;
                                q_list_navigation_app.resolve(result.list_navigation_app);
                            },
                            function (error) {
                                result.list_navigation_app = [];
                                q_list_navigation_app.resolve(result.list_navigation_app);
                            });
                        var q_list_navigation_app_values = $q.defer();
                        promises.push(q_list_navigation_app_values);
                        _Settings.getValue("list_navigation_app_values", "array",
                            function (res) {
                                result.list_navigation_app_values = res;
                                q_list_navigation_app_values.resolve(result.list_navigation_app_values);
                            },
                            function (error) {
                                result.list_navigation_app_values = [];
                                q_list_navigation_app_values.resolve(result.list_navigation_app_values);
                            });
                        var q_selected_navigation_app_name = $q.defer();
                        promises.push(q_selected_navigation_app_name);
                        _Settings.getValue("selected_navigation_app_name", "string",
                            function (res) {
                                result.selected_navigation_app_name = res;
                                q_selected_navigation_app_name.resolve(result.selected_navigation_app_name);
                            },
                            function (error) {
                                result.selected_navigation_app_name = "";
                                q_selected_navigation_app_name.resolve(result.selected_navigation_app_name);
                            });
                        var q_selected_navigation_pkg_name = $q.defer();
                        promises.push(q_selected_navigation_pkg_name);
                        _Settings.getValue("selected_navigation_pkg_name", "string",
                            function (res) {
                                result.selected_navigation_pkg_name = res;
                                q_selected_navigation_pkg_name.resolve(result.selected_navigation_pkg_name);
                            },
                            function (error) {
                                result.selected_navigation_pkg_name = "";
                                q_selected_navigation_pkg_name.resolve(result.selected_navigation_pkg_name);
                            });
                        var q_parking_notification = $q.defer();
                        promises.push(q_parking_notification);
                        _Settings.getValue("parking_notification", "boolean",
                            function (res) {
                                result.parking_notification = res;
                                q_parking_notification.resolve(result.parking_notification);
                            },
                            function (error) {
                                result.parking_notification = false;
                                q_parking_notification.resolve(result.parking_notification);
                            });

                        //// Backup Settings
                        var q_cloud_backup = $q.defer();
                        promises.push(q_cloud_backup);
                        _Settings.getValue("cloud_backup", "boolean",
                            function (res) {
                                result.cloud_backup = res;
                                q_cloud_backup.resolve(result.cloud_backup);
                            },
                            function (error) {
                                result.cloud_backup = false;
                                q_cloud_backup.resolve(result.cloud_backup);
                            });

                        //// Alerts Settings
                        var q_collision_alert = $q.defer();
                        promises.push(q_collision_alert);
                        _Settings.getValue("collision_alert", "boolean",
                            function (res) {
                                result.collision_alert = res;
                                q_collision_alert.resolve(result.collision_alert);
                            },
                            function (error) {
                                result.collision_alert = false;
                                q_collision_alert.resolve(result.collision_alert);
                            });
                        var q_off_road_warning = $q.defer();
                        promises.push(q_off_road_warning);
                        _Settings.getValue("off_road_warning", "boolean",
                            function (res) {
                                result.off_road_warning = res;
                                q_off_road_warning.resolve(result.off_road_warning);
                            },
                            function (error) {
                                result.off_road_warning = false;
                                q_off_road_warning.resolve(result.off_road_warning);
                            });
                        var q_tailgating_alert = $q.defer();
                        promises.push(q_tailgating_alert);
                        _Settings.getValue("tailgating_alert", "boolean",
                            function (res) {
                                result.tailgating_alert = res;
                                q_tailgating_alert.resolve(result.tailgating_alert);
                            },
                            function (error) {
                                result.tailgating_alert = false;
                                q_tailgating_alert.resolve(result.tailgating_alert);
                            });
                        var q_speeding_alert = $q.defer();
                        promises.push(q_speeding_alert);
                        _Settings.getValue("speeding_alert", "boolean",
                            function (res) {
                                result.speeding_alert = res;
                                q_speeding_alert.resolve(result.speeding_alert);
                            },
                            function (error) {
                                result.speeding_alert = false;
                                q_speeding_alert.resolve(result.speeding_alert);
                            });

                        //// Advanced Settings
                        var q_speed_sign_alert = $q.defer();
                        promises.push(q_speed_sign_alert);
                        _Settings.getValue("speed_sign_alert", "boolean",
                            function (res) {
                                result.speed_sign_alert = res;
                                q_speed_sign_alert.resolve(result.speed_sign_alert);
                            },
                            function (error) {
                                result.speed_sign_alert = false;
                                q_speed_sign_alert.resolve(result.speed_sign_alert);
                            });
                        var q_show_speed_sign = $q.defer();
                        promises.push(q_show_speed_sign);
                        _Settings.getValue("show_speed_sign", "array",
                            function (res) {
                                result.show_speed_sign = res;
                                q_show_speed_sign.resolve(result.show_speed_sign);
                            },
                            function (error) {
                                result.show_speed_sign = [];
                                q_show_speed_sign.resolve(result.show_speed_sign);
                            });
                        var q_show_speed_sign_values = $q.defer();
                        promises.push(q_show_speed_sign_values);
                        _Settings.getValue("show_speed_sign_values", "array",
                            function (res) {
                                result.show_speed_sign_values = res;
                                q_show_speed_sign_values.resolve(result.show_speed_sign_values);
                            },
                            function (error) {
                                result.show_speed_sign_values = [];
                                q_show_speed_sign_values.resolve(result.show_speed_sign_values);
                            });
                        var q_selected_show_speed_sign = $q.defer();
                        promises.push(q_selected_show_speed_sign);
                        _Settings.getValue("selected_show_speed_sign", "string",
                            function (res) {
                                result.selected_show_speed_sign = res;
                                q_selected_show_speed_sign.resolve(result.selected_show_speed_sign);
                            },
                            function (error) {
                                result.selected_show_speed_sign = false;
                                q_selected_show_speed_sign.resolve(result.selected_show_speed_sign);
                            });
                        var q_selected_tsr_time_value = $q.defer();
                        promises.push(q_selected_tsr_time_value);
                        _Settings.getValue("selected_tsr_time_value", "long",
                            function (res) {
                                result.selected_tsr_time_value = res;
                                q_selected_tsr_time_value.resolve(result.selected_tsr_time_value);
                            },
                            function (error) {
                                result.selected_tsr_time_value = false;
                                q_selected_tsr_time_value.resolve(result.selected_tsr_time_value);
                            });
                        var q_limit_max_speed = $q.defer();
                        promises.push(q_limit_max_speed);
                        _Settings.getValue("limit_max_speed", "boolean",
                            function (res) {
                                result.limit_max_speed = res;
                                q_limit_max_speed.resolve(result.limit_max_speed);
                            },
                            function (error) {
                                result.limit_max_speed = false;
                                q_limit_max_speed.resolve(result.limit_max_speed);
                            });
                        var q_max_speed_value = $q.defer();
                        promises.push(q_max_speed_value);
                        _Settings.getValue("max_speed_value", "int",
                            function (res) {
                                result.max_speed_value = res;
                                q_max_speed_value.resolve(result.max_speed_value);
                            },
                            function (error) {
                                result.max_speed_value = 65;
                                q_max_speed_value.resolve(result.max_speed_value);
                            });
                        var q_speed_limit_range_top = $q.defer();
                        promises.push(q_speed_limit_range_top);
                        _Settings.getValue("speed_limit_range_top", "int",
                            function (res) {
                                result.speed_limit_range_top = res;
                                q_speed_limit_range_top.resolve(result.speed_limit_range_top);
                            },
                            function (error) {
                                result.speed_limit_range_top = 140;
                                q_speed_limit_range_top.resolve(result.speed_limit_range_top);
                            });
                        var q_speed_limit_range_bottom = $q.defer();
                        promises.push(q_speed_limit_range_bottom);
                        _Settings.getValue("speed_limit_range_bottom", "int",
                            function (res) {
                                result.speed_limit_range_bottom = res;
                                q_speed_limit_range_bottom.resolve(result.speed_limit_range_bottom);
                            },
                            function (error) {
                                result.speed_limit_range_bottom = 50;
                                q_speed_limit_range_bottom.resolve(result.speed_limit_range_bottom);
                            });
                        //_Settings.getValue("tailgating_alert_time", "int",
                        //    function(res) {
                        // result.tailgating_alert_time = res / 1000;
                        // },
                        //    function(error) {
                        // return 1;
                        // });
                        var q_selected_tailgating_alert_time_value = $q.defer();
                        promises.push(q_selected_tailgating_alert_time_value);
                        _Settings.getValue("selected_tailgating_alert_time_value", "int",
                            function (res) {
                                result.selected_tailgating_alert_time_value = res / 1000;
                                q_selected_tailgating_alert_time_value.resolve(result.selected_tailgating_alert_time_value);
                            },
                            function (error) {
                                result.selected_tailgating_alert_time_value = 0;
                                q_selected_tailgating_alert_time_value.resolve(result.selected_tailgating_alert_time_value);
                            });
                        var q_selected_tailgating_alert_time = $q.defer();
                        promises.push(q_selected_tailgating_alert_time);
                        _Settings.getValue("selected_tailgating_alert_time", "string",
                            function (res) {
                                result.selected_tailgating_alert_time = res;
                                q_selected_tailgating_alert_time.resolve(result.selected_tailgating_alert_time);
                            },
                            function (error) {
                                result.selected_tailgating_alert_time = "";
                                q_selected_tailgating_alert_time.resolve(result.selected_tailgating_alert_time);
                            });
                        var q_show_hmw_values = $q.defer();
                        promises.push(q_show_hmw_values);
                        _Settings.getValue("show_hmw_values", "array",
                            function (res) {
                                result.show_hmw_values = res;
                                q_show_hmw_values.resolve(result.show_hmw_values);
                            },
                            function (error) {
                                result.show_hmw_values = [];
                                q_show_hmw_values.resolve(result.show_hmw_values);
                            });
                        var q_tailgating_alert_time = $q.defer();
                        promises.push(q_tailgating_alert_time);
                        _Settings.getValue("tailgating_alert_time", "array",
                            function (res) {
                                result.tailgating_alert_time = res;
                                q_tailgating_alert_time.resolve(result.tailgating_alert_time);
                            },
                            function (error) {
                                result.tailgating_alert_time = [];
                                q_tailgating_alert_time.resolve(result.tailgating_alert_time);
                            });

                        var q_limit_video_length = $q.defer();
                        promises.push(q_limit_video_length);
                        _Settings.getValue("limit_video_length", "boolean",
                            function (res) {
                                result.limit_video_length = res;
                                q_limit_video_length.resolve(result.limit_video_length);
                            },
                            function (error) {
                                result.limit_video_length = false;
                                q_limit_video_length.resolve(result.limit_video_length);
                            });
                        //_Settings.getValue("video_max_length", "int",
                        //    function(res) {
                        // result.video_max_length = res;
                        // },
                        //    function(error) {
                        // return 0;
                        // });
                        var q_video_max_length_value = $q.defer();
                        promises.push(q_video_max_length_value);
                        _Settings.getValue("video_max_length_value", "int",
                            function (res) {
                                result.video_max_length_value = res;
                                q_video_max_length_value.resolve(result.video_max_length_value);
                            },
                            function (error) {
                                result.video_max_length_value = [];
                                q_video_max_length_value.resolve(result.video_max_length_value);
                            });
                        var q_video_max_length = $q.defer();
                        promises.push(q_video_max_length);
                        _Settings.getValue("video_max_length", "string",
                            function (res) {
                                result.video_max_length = res;
                                q_video_max_length.resolve(result.video_max_length);
                            },
                            function (error) {
                                result.video_max_length = [];
                                q_video_max_length.resolve(result.video_max_length);
                            });
                        var q_video_max_length_names = $q.defer();
                        promises.push(q_video_max_length_names);
                        _Settings.getValue("video_max_length_names", "array",
                            function (res) {
                                result.q_video_max_length_names = res;
                                q_video_max_length_names.resolve(result.q_video_max_length_names);
                            },
                            function (error) {
                                result.q_video_max_length_names = false;
                                q_video_max_length_names.resolve(result.q_video_max_length_names);
                            });
                        var q_video_max_length_values = $q.defer();
                        promises.push(q_video_max_length_values);
                        _Settings.getValue("video_max_length_values", "array",
                            function (res) {
                                result.video_max_length_values = res;
                                q_video_max_length_values.resolve(result.video_max_length_values);
                            },
                            function (error) {
                                result.video_max_length_values = false;
                                q_video_max_length_values.resolve(result.video_max_length_values);
                            });

                        var q_prodashboard = $q.defer();
                        promises.push(q_prodashboard);
                        _Settings.getValue("com.ionroad.prodashboard", "boolean",
                            function (res) {
                                result.prodashboard = res;
                                q_prodashboard.resolve(result.prodashboard);
                            },
                            function (error) {
                                result.prodashboard = false;
                                q_prodashboard.resolve(result.prodashboard);
                            });

                        return $q.all(promises);
                    },

                    _IsPro: ["_Utils", "$q", "$rootScope", function(_Utils, $q, $rootScope) {
                      var deferred = $q.defer();

                      deferred.resolve($rootScope.Settings.prodashboard);

                      return deferred.promise;
                    }]
                }
            })
            .state('test', {
                url: '/test',
                templateUrl: 'templates/test_android.html',
                controller: 'TestCtrl',
                resolve: {
                    _SettingsLoader: function(_Settings) {
                        // Load the settings from the settings file
                        if (!_Settings.initialized())
                            return;

                        _Settings.load();
                    }
                }
            })
            .state('intro', {
                url: '/intro',
                templateUrl: 'templates/intro_android.html',
                controller: 'IntroCtrl',
                onExit: function ($ionicPlatform, _Settings) {
                    $ionicPlatform.ready(function () {

                        if (!_Settings.initialized()) {
                            return;
                        }

                        _Settings.load();

                        _Settings.putValue("is_first_app_run", false, "boolean",
                            function (result) {
                                console.log("Succesfully written to the settings the first run of the app");
                            }, function (error) {
                                console.log("Error writing to the settings that the app ran for the first time");
                            });
                    });
                }
            })
            .state('login', {
                url: '/login/:return_state',
                templateUrl: 'templates/login.html',
                controller: 'LoginCtrl'
            })
            .state('drives', {
                url: '/drives',
                templateUrl: 'templates/drives.html',
                controller: 'MyDrivesCtrl',
                resolve: {
                    _AllRuns: ["MyDrivesService", "_Utils", "$q", "$rootScope", function(MyDrivesService, _Utils, $q, $rootScope) {
                        var deferred = $q.defer();

                        MyDrivesService.getAllRuns(function (runs) {
                            // Initialize the runs list
                            var result = [];

                            for (i = 0; i < runs.length; i++) {
                                result[i] = {
                                    RunId: runs[i].RunId,
                                    Timestamp: _Utils.getShortReadableTimestamp(runs[i].StartTime),
                                    When: _Utils.getDriveDateText(runs[i].EndTime),
                                    StartTime: _Utils.getTime(runs[i].StartTime),
                                    StartTimeMetric: _Utils.getTimeMetric(runs[i].StartTime),
                                    EndTime: _Utils.getTime(runs[i].EndTime),
                                    EndTimeMetric: _Utils.getTimeMetric(runs[i].EndTime),
                                    Distance: _Utils.getDistance(runs[i].TotalDistance),
                                    DistanceMetric: _Utils.getDistanceMetric(runs[i].TotalDistance, $rootScope.Settings.speed_units),
                                    Duration: _Utils.getDuration(runs[i].StartTime, runs[i].EndTime),
                                    DurationMetric: _Utils.getDurationMetric(runs[i].StartTime, runs[i].EndTime)
                                };
                            }

                            deferred.resolve(result);
                        });

                        return deferred.promise;
                    }],

                    _TotalDistance: function(MyDrivesService, $q) {
                        var deferred = $q.defer();

                        MyDrivesService.getTotalDistance(function (result) {
                            deferred.resolve(result);
                        });

                        return deferred.promise;
                    },

                    _TotalAlerts: function(MyDrivesService, $q) {
                        var deferred = $q.defer();

                        MyDrivesService.getTotalAlerts(function (result) {
                            deferred.resolve(result);
                        });

                        return deferred.promise;
                    },

                    _TotalTime: function(MyDrivesService, $q) {
                        var deferred = $q.defer();

                        MyDrivesService.getTotalTime(function (result) {
                            deferred.resolve(result);
                        });

                        return deferred.promise;
                    }
                }
            })
            .state('drive', {
                url: '/drive/:driveId',
                templateUrl: 'templates/drive-analysis.html',
                controller: 'DriveCtrl',
                resolve: {
                    _Delay: function($q, $timeout) {
                        var deferred = $q.defer();
                        $timeout(function() {
                            deferred.resolve('Done!');
                        }, 1000);
                        return deferred.promise;
                    },

                    _RunInfo: function(DriveService, $q, $stateParams) {
                        var deferred = $q.defer();

                        DriveService.getRun($stateParams.driveId, function (result) {
                            deferred.resolve(result);
                        });

                        return deferred.promise;
                    },

                    _RouteInfo: function(DriveService, $q, $stateParams) {
                        var deferred = $q.defer();

                        DriveService.getRoute($stateParams.driveId, function (result) {
                            deferred.resolve(result);
                        });

                        return deferred.promise;
                    },

                    _Alerts: ["DriveService", "_Settings", "$q", "$stateParams", "$rootScope", function(DriveService, _Settings, $q, $stateParams, $rootScope) {
                        // Common Settings
                        var deferred = $q.defer();

                        DriveService.getAlerts($stateParams.driveId, $rootScope.Settings.selected_tailgating_alert_time_value, function (result) {
                            deferred.resolve(result);
                        });

                        return deferred.promise;
                    }],

                    _IsPro: ["_Utils", "$q", "$rootScope", function(_Utils, $q, $rootScope) {
                      var deferred = $q.defer();

                      deferred.resolve($rootScope.Settings.prodashboard);

                      return deferred.promise;
                    }]
                }
            })
            .state('drive.collision', {
                url: '/collision',
                controller: 'DriveCtrl',
                views: {
                    analysis: {templateUrl: 'templates/drive-analysis-collision.html'},
                    alert: {templateUrl: 'templates/drive-analysis-collision-alert.html'}
                }
            })
            .state('drive.tailgating', {
                url: '/tailgating',
                controller: 'DriveCtrl',
                views: {
                    analysis: {templateUrl: 'templates/drive-analysis-tailgating.html'}
                }
            })
            .state('drive.speeding', {
                url: '/speeding',
                controller: 'DriveCtrl',
                views: {
                    analysis: {templateUrl: 'templates/drive-analysis-speeding.html'},
                    alert: {templateUrl: 'templates/drive-analysis-speeding-alert.html'}
                }
            })
            .state('drive.offroad', {
                url: '/offroad',
                controller: 'DriveCtrl',
                views: {
                    analysis: {templateUrl: 'templates/drive-analysis-offroad.html'},
                    alert: {templateUrl: 'templates/drive-analysis-speeding-alert.html'}
                }
            })
            .state('settings', {
                url: '/settings',
                templateUrl: 'templates/settings.html',
                controller: 'SettingsCtrl',
                resolve: {
                    _IsUserLoggedIn: function(UsersService, $q) {
                        var deferred = $q.defer();

                        UsersService.isUserLoggedIn(function (result) {
                            deferred.resolve(result);
                        });

                        return deferred.promise;
                    },

                    _SettingsData: function(_Settings, $q) {
                        var promises = [];
                        var result = {};

                        // Load the settings from the settings file
                        if (!_Settings.initialized())
                            return;

                        _Settings.load();

                        // Common Settings
                        var q_should_reset_settings = $q.defer();
                        promises.push(q_should_reset_settings);
                        _Settings.getValue("should_reset_settings", "boolean",
                            function (res) {
                                result.should_reset_settings = res;
                                q_should_reset_settings.resolve(result.should_reset_settings);
                            },
                            function (error) {
                                result.should_reset_settings = true;
                                q_should_reset_settings.resolve(result.should_reset_settings);
                            });

                        // Dev Settings
                        var q_debug_mode = $q.defer();
                        promises.push(q_debug_mode);
                        _Settings.getValue("debug_mode", "boolean",
                            function (res) {
                                result.debug_mode = res;
                                q_debug_mode.resolve(result.debug_mode);
                            },
                            function (error) {
                                result.debug_mode = true;
                                q_debug_mode.resolve(result.debug_mode);
                            });
                        var q_show_debug_info = $q.defer();
                        promises.push(q_show_debug_info);
                        _Settings.getValue("show_debug_info", "boolean",
                            function (res) {
                                result.show_debug_info = res;
                                q_show_debug_info.resolve(result.show_debug_info);
                            },
                            function (error) {
                                result.show_debug_info = true;
                                q_show_debug_info.resolve(result.show_debug_info);
                            });
                        var q_enable_sounds = $q.defer();
                        promises.push(q_enable_sounds);
                        _Settings.getValue("enable_sounds", "boolean",
                            function (res) {
                                result.enable_sounds = res;
                                q_enable_sounds.resolve(result.enable_sounds);
                            },
                            function (error) {
                                result.enable_sounds = true;
                                q_enable_sounds.resolve(result.enable_sounds);
                            });
                        var q_is_first_app_run = $q.defer();
                        promises.push(q_is_first_app_run);
                        _Settings.getValue("is_first_app_run", "boolean",
                            function (res) {
                                result.is_first_app_run = res;
                                q_is_first_app_run.resolve(result.is_first_app_run);
                            },
                            function (error) {
                                result.is_first_app_run = true;
                                q_is_first_app_run.resolve(result.is_first_app_run);
                            });

                        // Basic Settings
                        var q_speed_units = $q.defer();
                        promises.push(q_speed_units);
                        _Settings.getValue("speed_units", "boolean",
                            function (res) {
                                result.speed_units = res;
                                q_speed_units.resolve(result.speed_units);
                            },
                            function (error) {
                                result.speed_units = true;
                                q_speed_units.resolve(result.speed_units);
                            });
                        var q_marker_information = $q.defer();
                        promises.push(q_marker_information);
                        _Settings.getValue("marker_information", "boolean",
                            function (res) {
                                result.marker_information = res;
                                q_marker_information.resolve(result.marker_information);
                            },
                            function (error) {
                                result.marker_information = false;
                                q_marker_information.resolve(result.marker_information);
                            });
                        var q_list_navigation_app = $q.defer();
                        promises.push(q_list_navigation_app);
                        _Settings.getValue("list_navigation_app", "array",
                            function (res) {
                                result.list_navigation_app = res;
                                q_list_navigation_app.resolve(result.list_navigation_app);
                            },
                            function (error) {
                                result.list_navigation_app = [];
                                q_list_navigation_app.resolve(result.list_navigation_app);
                            });
                        var q_list_navigation_app_values = $q.defer();
                        promises.push(q_list_navigation_app_values);
                        _Settings.getValue("list_navigation_app_values", "array",
                            function (res) {
                                result.list_navigation_app_values = res;
                                q_list_navigation_app_values.resolve(result.list_navigation_app_values);
                            },
                            function (error) {
                                result.list_navigation_app_values = [];
                                q_list_navigation_app_values.resolve(result.list_navigation_app_values);
                            });
                        var q_selected_navigation_app_name = $q.defer();
                        promises.push(q_selected_navigation_app_name);
                        _Settings.getValue("selected_navigation_app_name", "string",
                            function (res) {
                                result.selected_navigation_app_name = res;
                                q_selected_navigation_app_name.resolve(result.selected_navigation_app_name);
                            },
                            function (error) {
                                result.selected_navigation_app_name = "";
                                q_selected_navigation_app_name.resolve(result.selected_navigation_app_name);
                            });
                        var q_selected_navigation_pkg_name = $q.defer();
                        promises.push(q_selected_navigation_pkg_name);
                        _Settings.getValue("selected_navigation_pkg_name", "string",
                            function (res) {
                                result.selected_navigation_pkg_name = res;
                                q_selected_navigation_pkg_name.resolve(result.selected_navigation_pkg_name);
                            },
                            function (error) {
                                result.selected_navigation_pkg_name = "";
                                q_selected_navigation_pkg_name.resolve(result.selected_navigation_pkg_name);
                            });
                        var q_parking_notification = $q.defer();
                        promises.push(q_parking_notification);
                        _Settings.getValue("parking_notification", "boolean",
                            function (res) {
                                result.parking_notification = res;
                                q_parking_notification.resolve(result.parking_notification);
                            },
                            function (error) {
                                result.parking_notification = false;
                                q_parking_notification.resolve(result.parking_notification);
                            });

                        //// Backup Settings
                        var q_cloud_backup = $q.defer();
                        promises.push(q_cloud_backup);
                        _Settings.getValue("cloud_backup", "boolean",
                            function (res) {
                                result.cloud_backup = res;
                                q_cloud_backup.resolve(result.cloud_backup);
                            },
                            function (error) {
                                result.cloud_backup = false;
                                q_cloud_backup.resolve(result.cloud_backup);
                            });

                        //// Alerts Settings
                        var q_collision_alert = $q.defer();
                        promises.push(q_collision_alert);
                        _Settings.getValue("collision_alert", "boolean",
                            function (res) {
                                result.collision_alert = res;
                                q_collision_alert.resolve(result.collision_alert);
                            },
                            function (error) {
                                result.collision_alert = false;
                                q_collision_alert.resolve(result.collision_alert);
                            });
                        var q_off_road_warning = $q.defer();
                        promises.push(q_off_road_warning);
                        _Settings.getValue("off_road_warning", "boolean",
                            function (res) {
                                result.off_road_warning = res;
                                q_off_road_warning.resolve(result.off_road_warning);
                            },
                            function (error) {
                                result.off_road_warning = false;
                                q_off_road_warning.resolve(result.off_road_warning);
                            });
                        var q_tailgating_alert = $q.defer();
                        promises.push(q_tailgating_alert);
                        _Settings.getValue("tailgating_alert", "boolean",
                            function (res) {
                                result.tailgating_alert = res;
                                q_tailgating_alert.resolve(result.tailgating_alert);
                            },
                            function (error) {
                                result.tailgating_alert = false;
                                q_tailgating_alert.resolve(result.tailgating_alert);
                            });
                        var q_speeding_alert = $q.defer();
                        promises.push(q_speeding_alert);
                        _Settings.getValue("speeding_alert", "boolean",
                            function (res) {
                                result.speeding_alert = res;
                                q_speeding_alert.resolve(result.speeding_alert);
                            },
                            function (error) {
                                result.speeding_alert = false;
                                q_speeding_alert.resolve(result.speeding_alert);
                            });

                        //// Advanced Settings
                        var q_speed_sign_alert = $q.defer();
                        promises.push(q_speed_sign_alert);
                        _Settings.getValue("speed_sign_alert", "boolean",
                            function (res) {
                                result.speed_sign_alert = res;
                                q_speed_sign_alert.resolve(result.speed_sign_alert);
                            },
                            function (error) {
                                result.speed_sign_alert = false;
                                q_speed_sign_alert.resolve(result.speed_sign_alert);
                            });
                        var q_show_speed_sign = $q.defer();
                        promises.push(q_show_speed_sign);
                        _Settings.getValue("show_speed_sign", "array",
                            function (res) {
                                result.show_speed_sign = res;
                                q_show_speed_sign.resolve(result.show_speed_sign);
                            },
                            function (error) {
                                result.show_speed_sign = [];
                                q_show_speed_sign.resolve(result.show_speed_sign);
                            });
                        var q_show_speed_sign_values = $q.defer();
                        promises.push(q_show_speed_sign_values);
                        _Settings.getValue("show_speed_sign_values", "array",
                            function (res) {
                                result.show_speed_sign_values = res;
                                q_show_speed_sign_values.resolve(result.show_speed_sign_values);
                            },
                            function (error) {
                                result.show_speed_sign_values = [];
                                q_show_speed_sign_values.resolve(result.show_speed_sign_values);
                            });
                        var q_selected_show_speed_sign = $q.defer();
                        promises.push(q_selected_show_speed_sign);
                        _Settings.getValue("selected_show_speed_sign", "string",
                            function (res) {
                                result.selected_show_speed_sign = res;
                                q_selected_show_speed_sign.resolve(result.selected_show_speed_sign);
                            },
                            function (error) {
                                result.selected_show_speed_sign = false;
                                q_selected_show_speed_sign.resolve(result.selected_show_speed_sign);
                            });
                        var q_selected_tsr_time_value = $q.defer();
                        promises.push(q_selected_tsr_time_value);
                        _Settings.getValue("selected_tsr_time_value", "long",
                            function (res) {
                                result.selected_tsr_time_value = res;
                                q_selected_tsr_time_value.resolve(result.selected_tsr_time_value);
                            },
                            function (error) {
                                result.selected_tsr_time_value = false;
                                q_selected_tsr_time_value.resolve(result.selected_tsr_time_value);
                            });
                        var q_limit_max_speed = $q.defer();
                        promises.push(q_limit_max_speed);
                        _Settings.getValue("limit_max_speed", "boolean",
                            function (res) {
                                result.limit_max_speed = res;
                                q_limit_max_speed.resolve(result.limit_max_speed);
                            },
                            function (error) {
                                result.limit_max_speed = false;
                                q_limit_max_speed.resolve(result.limit_max_speed);
                            });
                        var q_max_speed_value = $q.defer();
                        promises.push(q_max_speed_value);
                        _Settings.getValue("max_speed_value", "int",
                            function (res) {
                                result.max_speed_value = res;
                                q_max_speed_value.resolve(result.max_speed_value);
                            },
                            function (error) {
                                result.max_speed_value = 65;
                                q_max_speed_value.resolve(result.max_speed_value);
                            });
                        var q_speed_limit_range_top = $q.defer();
                        promises.push(q_speed_limit_range_top);
                        _Settings.getValue("speed_limit_range_top", "int",
                            function (res) {
                                result.speed_limit_range_top = res;
                                q_speed_limit_range_top.resolve(result.speed_limit_range_top);
                            },
                            function (error) {
                                result.speed_limit_range_top = 140;
                                q_speed_limit_range_top.resolve(result.speed_limit_range_top);
                            });
                        var q_speed_limit_range_bottom = $q.defer();
                        promises.push(q_speed_limit_range_bottom);
                        _Settings.getValue("speed_limit_range_bottom", "int",
                            function (res) {
                                result.speed_limit_range_bottom = res;
                                q_speed_limit_range_bottom.resolve(result.speed_limit_range_bottom);
                            },
                            function (error) {
                                result.speed_limit_range_bottom = 50;
                                q_speed_limit_range_bottom.resolve(result.speed_limit_range_bottom);
                            });
                        //_Settings.getValue("tailgating_alert_time", "int",
                        //    function(res) {
                        // result.tailgating_alert_time = res / 1000;
                        // },
                        //    function(error) {
                        // return 1;
                        // });
                        var q_selected_tailgating_alert_time_value = $q.defer();
                        promises.push(q_selected_tailgating_alert_time_value);
                        _Settings.getValue("selected_tailgating_alert_time_value", "int",
                            function (res) {
                                result.selected_tailgating_alert_time_value = res / 1000;
                                q_selected_tailgating_alert_time_value.resolve(result.selected_tailgating_alert_time_value);
                            },
                            function (error) {
                                result.selected_tailgating_alert_time_value = 0;
                                q_selected_tailgating_alert_time_value.resolve(result.selected_tailgating_alert_time_value);
                            });
                        var q_selected_tailgating_alert_time = $q.defer();
                        promises.push(q_selected_tailgating_alert_time);
                        _Settings.getValue("selected_tailgating_alert_time", "string",
                            function (res) {
                                result.selected_tailgating_alert_time = res;
                                q_selected_tailgating_alert_time.resolve(result.selected_tailgating_alert_time);
                            },
                            function (error) {
                                result.selected_tailgating_alert_time = "";
                                q_selected_tailgating_alert_time.resolve(result.selected_tailgating_alert_time);
                            });
                        var q_show_hmw_values = $q.defer();
                        promises.push(q_show_hmw_values);
                        _Settings.getValue("show_hmw_values", "array",
                            function (res) {
                                result.show_hmw_values = res;
                                q_show_hmw_values.resolve(result.show_hmw_values);
                            },
                            function (error) {
                                result.show_hmw_values = [];
                                q_show_hmw_values.resolve(result.show_hmw_values);
                            });
                        var q_tailgating_alert_time = $q.defer();
                        promises.push(q_tailgating_alert_time);
                        _Settings.getValue("tailgating_alert_time", "array",
                            function (res) {
                                result.tailgating_alert_time = res;
                                q_tailgating_alert_time.resolve(result.tailgating_alert_time);
                            },
                            function (error) {
                                result.tailgating_alert_time = [];
                                q_tailgating_alert_time.resolve(result.tailgating_alert_time);
                            });

                        var q_limit_video_length = $q.defer();
                        promises.push(q_limit_video_length);
                        _Settings.getValue("limit_video_length", "boolean",
                            function (res) {
                                result.limit_video_length = res;
                                q_limit_video_length.resolve(result.limit_video_length);
                            },
                            function (error) {
                                result.limit_video_length = false;
                                q_limit_video_length.resolve(result.limit_video_length);
                            });
                        //_Settings.getValue("video_max_length", "int",
                        //    function(res) {
                        // result.video_max_length = res;
                        // },
                        //    function(error) {
                        // return 0;
                        // });
                        var q_video_max_length_value = $q.defer();
                        promises.push(q_video_max_length_value);
                        _Settings.getValue("video_max_length_value", "int",
                            function (res) {
                                result.video_max_length_value = res;
                                q_video_max_length_value.resolve(result.video_max_length_value);
                            },
                            function (error) {
                                result.video_max_length_value = [];
                                q_video_max_length_value.resolve(result.video_max_length_value);
                            });
                        var q_video_max_length = $q.defer();
                        promises.push(q_video_max_length);
                        _Settings.getValue("video_max_length", "string",
                            function (res) {
                                result.video_max_length = res;
                                q_video_max_length.resolve(result.video_max_length);
                            },
                            function (error) {
                                result.video_max_length = [];
                                q_video_max_length.resolve(result.video_max_length);
                            });
                        var q_video_max_length_names = $q.defer();
                        promises.push(q_video_max_length_names);
                        _Settings.getValue("video_max_length_names", "array",
                            function (res) {
                                result.q_video_max_length_names = res;
                                q_video_max_length_names.resolve(result.q_video_max_length_names);
                            },
                            function (error) {
                                result.q_video_max_length_names = false;
                                q_video_max_length_names.resolve(result.q_video_max_length_names);
                            });
                        var q_video_max_length_values = $q.defer();
                        promises.push(q_video_max_length_values);
                        _Settings.getValue("video_max_length_values", "array",
                            function (res) {
                                result.video_max_length_values = res;
                                q_video_max_length_values.resolve(result.video_max_length_values);
                            },
                            function (error) {
                                result.video_max_length_values = false;
                                q_video_max_length_values.resolve(result.video_max_length_values);
                            });

                        var q_prodashboard = $q.defer();
                        promises.push(q_prodashboard);
                        _Settings.getValue("com.ionroad.prodashboard", "boolean",
                            function (res) {
                                result.prodashboard = res;
                                q_prodashboard.resolve(result.prodashboard);
                            },
                            function (error) {
                                result.prodashboard = false;
                                q_prodashboard.resolve(result.prodashboard);
                            });

                        return $q.all(promises);
                    }
                }
            })
            .state('parking', {
                url: '/parking',
                templateUrl: 'templates/parking.html',
                controller: 'ParkingCtrl',
                resolve: {
                    _ReminderInfo: function(ParkingService, _Utils, $q) {
                        var deferred = $q.defer();

                        ParkingService.getReminderInfo(function (reminder) {
                            if (!reminder.ReminderTime) {
                                deferred.resolve(null);
                            }
                            else {
                                deferred.resolve(reminder.ReminderTime);
                            }
                        });

                        return deferred.promise;
                    },

                    _ParkingInfo: function(ParkingService, $q) {
                        var deferred = $q.defer();

                        ParkingService.getParkingInfo(function (result) {
                            deferred.resolve(result);
                        });

                        return deferred.promise;
                    },

                    _ParkingPhoto: function(ParkingService, $q) {
                        var deferred = $q.defer();

                        ParkingService.getParkingPhoto(function (result) {
                            deferred.resolve(result);
                        });

                        return deferred.promise;
                    }
                }
            })
            .state('parking_location_change', {
                url: '/parking_location_change',
                templateUrl: 'templates/parking_change_location.html',
                controller: 'ParkingCtrl',
                resolve: {
                    _ReminderInfo: function(ParkingService, _Utils, $q) {
                        var deferred = $q.defer();

                        ParkingService.getReminderInfo(function (reminder) {
                            if (!reminder.ReminderTime) {
                                deferred.resolve(null);
                            }
                            else {
                                deferred.resolve(reminder.ReminderTime);
                            }
                        });

                        return deferred.promise;
                    },

                    _ParkingInfo: function(ParkingService, $q) {
                        var deferred = $q.defer();

                        ParkingService.getParkingInfo(function (result) {
                            deferred.resolve(result);
                        });

                        return deferred.promise;
                    },

                    _ParkingPhoto: function(ParkingService, $q) {
                        var deferred = $q.defer();

                        ParkingService.getParkingPhoto(function (result) {
                            deferred.resolve(result);
                        });

                        return deferred.promise;
                    }
                }
            })
            .state('parking_photo_main', {
                url: '/parking_photo_main',
                templateUrl: 'templates/parking_photo.html',
                controller: 'ParkingCtrl',
                resolve: {
                    _ReminderInfo: function(ParkingService, _Utils, $q) {
                        var deferred = $q.defer();

                        ParkingService.getReminderInfo(function (reminder) {
                            if (!reminder.ReminderTime) {
                                deferred.resolve(null);
                            }
                            else {
                                deferred.resolve(reminder.ReminderTime);
                            }
                        });

                        return deferred.promise;
                    },

                    _ParkingInfo: function(ParkingService, $q) {
                        var deferred = $q.defer();

                        ParkingService.getParkingInfo(function (result) {
                            deferred.resolve(result);
                        });

                        return deferred.promise;
                    },

                    _ParkingPhoto: function(ParkingService, $q) {
                        var deferred = $q.defer();

                        ParkingService.getParkingPhoto(function (result) {
                            deferred.resolve(result);
                        });

                        return deferred.promise;
                    }
                }
            })
            .state('parking_photo_change', {
                url: '/parking_photo_change',
                templateUrl: 'templates/parking_change_photo.html',
                controller: 'ParkingCtrl',
                resolve: {
                    _ReminderInfo: function(ParkingService, _Utils, $q) {
                        var deferred = $q.defer();

                        ParkingService.getReminderInfo(function (reminder) {
                            if (!reminder.ReminderTime) {
                                deferred.resolve(null);
                            }
                            else {
                                deferred.resolve(reminder.ReminderTime);
                            }
                        });

                        return deferred.promise;
                    },

                    _ParkingInfo: function(ParkingService, $q) {
                        var deferred = $q.defer();

                        ParkingService.getParkingInfo(function (result) {
                            deferred.resolve(result);
                        });

                        return deferred.promise;
                    },

                    _ParkingPhoto: function(ParkingService, $q) {
                        var deferred = $q.defer();

                        ParkingService.getParkingPhoto(function (result) {
                            deferred.resolve(result);
                        });

                        return deferred.promise;
                    }
                }
            });

        // if none of the above states are matched, use this as the fallback
        $urlRouterProvider.otherwise('/');
    });
